#!/bin/sh
# ----------------------------------------------------------------------------
#  Copyright 2001-2006 The Apache Software Foundation.
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
# ----------------------------------------------------------------------------
#
#   Copyright (c) 2001-2006 The Apache Software Foundation.  All rights
#   reserved.


# resolve links - $0 may be a softlink
PRG="$0"

while [ -h "$PRG" ]; do
  ls=`ls -ld "$PRG"`
  link=`expr "$ls" : '.*-> \(.*\)$'`
  if expr "$link" : '/.*' > /dev/null; then
    PRG="$link"
  else
    PRG=`dirname "$PRG"`/"$link"
  fi
done

PRGDIR=`dirname "$PRG"`
BASEDIR=`cd "$PRGDIR/.." >/dev/null; pwd`



# OS specific support.  $var _must_ be set to either true or false.
cygwin=false;
darwin=false;
case "`uname`" in
  CYGWIN*) cygwin=true ;;
  Darwin*) darwin=true
           if [ -z "$JAVA_VERSION" ] ; then
             JAVA_VERSION="CurrentJDK"
           else
             echo "Using Java version: $JAVA_VERSION"
           fi
		   if [ -z "$JAVA_HOME" ]; then
		      if [ -x "/usr/libexec/java_home" ]; then
			      JAVA_HOME=`/usr/libexec/java_home`
			  else
			      JAVA_HOME=/System/Library/Frameworks/JavaVM.framework/Versions/${JAVA_VERSION}/Home
			  fi
           fi       
           ;;
esac

if [ -z "$JAVA_HOME" ] ; then
  if [ -r /etc/gentoo-release ] ; then
    JAVA_HOME=`java-config --jre-home`
  fi
fi

# For Cygwin, ensure paths are in UNIX format before anything is touched
if $cygwin ; then
  [ -n "$JAVA_HOME" ] && JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
  [ -n "$CLASSPATH" ] && CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
fi

# If a specific java binary isn't specified search for the standard 'java' binary
if [ -z "$JAVACMD" ] ; then
  if [ -n "$JAVA_HOME"  ] ; then
    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
      # IBM's JDK on AIX uses strange locations for the executables
      JAVACMD="$JAVA_HOME/jre/sh/java"
    else
      JAVACMD="$JAVA_HOME/bin/java"
    fi
  else
    JAVACMD=`which java`
  fi
fi

if [ ! -x "$JAVACMD" ] ; then
  echo "Error: JAVA_HOME is not defined correctly." 1>&2
  echo "  We cannot execute $JAVACMD" 1>&2
  exit 1
fi

if [ -z "$REPO" ]
then
  REPO="$BASEDIR"/repo
fi

CLASSPATH=$CLASSPATH_PREFIX:"$BASEDIR"/conf:"$REPO"/com/xiaomi/infra/galaxy/galaxy-fds-sdk-java/2.1-SNAPSHOT/galaxy-fds-sdk-java-2.1-SNAPSHOT.jar:"$REPO"/com/google/guava/guava/16.0.1/guava-16.0.1.jar:"$REPO"/commons-lang/commons-lang/2.4/commons-lang-2.4.jar:"$REPO"/com/google/code/gson/gson/2.3.1/gson-2.3.1.jar:"$REPO"/commons-io/commons-io/2.1/commons-io-2.1.jar:"$REPO"/com/xiaomi/infra/galaxy/galaxy-fds-core/2.1-SNAPSHOT/galaxy-fds-core-2.1-SNAPSHOT.jar:"$REPO"/org/json/json/20090211/json-20090211.jar:"$REPO"/org/apache/httpcomponents/httpclient/4.4.1/httpclient-4.4.1.jar:"$REPO"/commons-logging/commons-logging/1.2/commons-logging-1.2.jar:"$REPO"/commons-codec/commons-codec/1.9/commons-codec-1.9.jar:"$REPO"/org/apache/httpcomponents/httpcore/4.4.1/httpcore-4.4.1.jar:"$REPO"/com/aliyun/oss/aliyun-sdk-oss/2.8.2/aliyun-sdk-oss-2.8.2.jar:"$REPO"/org/jdom/jdom/1.1/jdom-1.1.jar:"$REPO"/net/sf/json-lib/json-lib/2.4/json-lib-2.4-jdk15.jar:"$REPO"/commons-beanutils/commons-beanutils/1.8.0/commons-beanutils-1.8.0.jar:"$REPO"/commons-collections/commons-collections/3.2.1/commons-collections-3.2.1.jar:"$REPO"/net/sf/ezmorph/ezmorph/1.0.6/ezmorph-1.0.6.jar:"$REPO"/args4j/args4j/2.0.26/args4j-2.0.26.jar:"$REPO"/org/slf4j/slf4j-api/1.6.1/slf4j-api-1.6.1.jar:"$REPO"/org/slf4j/slf4j-log4j12/1.6.1/slf4j-log4j12-1.6.1.jar:"$REPO"/log4j/log4j/1.2.16/log4j-1.2.16.jar:"$REPO"/com/ksyun/ks3-kss-java-sdk/0.8.6/ks3-kss-java-sdk-0.8.6.jar:"$REPO"/joda-time/joda-time/2.10.2/joda-time-2.10.2.jar:"$REPO"/com/amazonaws/aws-java-sdk-s3/1.11.63/aws-java-sdk-s3-1.11.63.jar:"$REPO"/com/amazonaws/aws-java-sdk-kms/1.11.63/aws-java-sdk-kms-1.11.63.jar:"$REPO"/com/amazonaws/aws-java-sdk-core/1.11.63/aws-java-sdk-core-1.11.63.jar:"$REPO"/software/amazon/ion/ion-java/1.0.1/ion-java-1.0.1.jar:"$REPO"/com/fasterxml/jackson/dataformat/jackson-dataformat-cbor/2.6.6/jackson-dataformat-cbor-2.6.6.jar:"$REPO"/com/amazonaws/jmespath-java/1.11.63/jmespath-java-1.11.63.jar:"$REPO"/com/fasterxml/jackson/core/jackson-databind/2.6.0/jackson-databind-2.6.0.jar:"$REPO"/com/fasterxml/jackson/core/jackson-annotations/2.6.0/jackson-annotations-2.6.0.jar:"$REPO"/com/fasterxml/jackson/core/jackson-core/2.6.0/jackson-core-2.6.0.jar:"$REPO"/com/xiaomi/infra/hbase-client/1.1.5.1/hbase-client-1.1.5.1.jar:"$REPO"/com/xiaomi/xiaomi-thrift-scribe/2.0.2/xiaomi-thrift-scribe-2.0.2.jar:"$REPO"/com/xiaomi/common/perfcounter/xiaomi-common-perfcounter/1.0-SNAPSHOT/xiaomi-common-perfcounter-1.0-20131029.074600-24.jar:"$REPO"/org/apache/commons/commons-lang3/3.1/commons-lang3-3.1.jar:"$REPO"/com/yammer/metrics/metrics-core/2.2.0/metrics-core-2.2.0.jar:"$REPO"/com/xiaomi/xiaomi-common-utils/1.0-SNAPSHOT/xiaomi-common-utils-1.0-20131029.074558-24.jar:"$REPO"/com/xiaomi/xiaomi-common-dal/1.0-SNAPSHOT/xiaomi-common-dal-1.0-20130128.032222-10.jar:"$REPO"/mysql/mysql-connector-java/5.1.10/mysql-connector-java-5.1.10.jar:"$REPO"/commons-pool/commons-pool/1.6/commons-pool-1.6.jar:"$REPO"/dom4j/dom4j/1.6.1/dom4j-1.6.1.jar:"$REPO"/xml-apis/xml-apis/1.0.b2/xml-apis-1.0.b2.jar:"$REPO"/jaxen/jaxen/1.1/jaxen-1.1.jar:"$REPO"/jdom/jdom/1.0/jdom-1.0.jar:"$REPO"/xom/xom/1.0/xom-1.0.jar:"$REPO"/xerces/xmlParserAPIs/2.6.2/xmlParserAPIs-2.6.2.jar:"$REPO"/xalan/xalan/2.6.0/xalan-2.6.0.jar:"$REPO"/com/ibm/icu/icu4j/2.6.1/icu4j-2.6.1.jar:"$REPO"/net/sf/jsqlparser/0.7.0/jsqlparser-0.7.0.jar:"$REPO"/com/xiaomi/infra/galaxy/fds-thirdpart-migration/1.16-SNAPSHOT/fds-thirdpart-migration-1.16-SNAPSHOT.jar

# For Cygwin, switch paths to Windows format before running java
if $cygwin; then
  [ -n "$CLASSPATH" ] && CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
  [ -n "$JAVA_HOME" ] && JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
  [ -n "$HOME" ] && HOME=`cygpath --path --windows "$HOME"`
  [ -n "$BASEDIR" ] && BASEDIR=`cygpath --path --windows "$BASEDIR"`
  [ -n "$REPO" ] && REPO=`cygpath --path --windows "$REPO"`
fi

exec "$JAVACMD" $JAVA_OPTS  \
  -classpath "$CLASSPATH" \
  -Dapp.name="migration-tool" \
  -Dapp.pid="$$" \
  -Dapp.repo="$REPO" \
  -Dapp.home="$BASEDIR" \
  -Dbasedir="$BASEDIR" \
  com.xiaomi.infra.galaxy.fds.MigrationToolMain \
  "$@"
